Bug 451859 - ptrace ATTACH, then CONT with signal fails
ptrace ATTACH, then CONT with signal fails
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: kernel (Show other bugs)
9
All Linux
low Severity medium
: ---
: ---
Assigned To: Kernel Maintainer List
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2008-06-17 15:54 EDT by Tom Fleck
Modified: 2009-07-14 14:05 EDT (History)
1 user (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-07-14 14:05:57 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Tom Fleck 2008-06-17 15:54:38 EDT
From Bugzilla Helper:
User-Agent: Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.8.1.14) Gecko/20080404 Firefox/2.0.0.14

Description of problem:
ptrace behavior apparently changed big-time between FC3=RHEL4=2.6.9 and FC6=2.6.18, such that continuing the debugged process with a signal after attaching no longer works.

Attached is my test program. It's long and verbose, I'm sorry, but I wanted to be clear. As comments say, there are 2 ways to build it that manifest the bug in different ways.

Tom

Version-Release number of selected component (if applicable):
glibc-2.5-3

How reproducible:
Always


Steps to Reproduce:
1. Compile test program:
gcc ptracebug.c -o ptrace_from_parent
2. Run test program:
./ptrace_from_parent


Actual Results:
--- Show that ptrace(CONT, blocked-signal) fails on FC6
 If test dones't print PASSED, it failed.
AFTER FORK, CHILD = 3440
APP=3440: wait for SIGUSR1 from DEB=3439
AFTER FORK, PARENT = 3439
DEB=3439 sleeping for a second
DEB=3439: ptrace attach to APP=3440
DEB=3439: CONT APP=3440 with signal 10
DEB=3439 looks ok
PID=3439: DEB OK


Expected Results:
 If test dones't print PASSED, it failed.
AFTER FORK, CHILD = 13766
APP=13766: wait for SIGUSR1 from DEB=13765
AFTER FORK, PARENT = 13765
DEB=13765 sleeping for a second
DEB=13765: ptrace attach to APP=13766
DEB=13765: CONT APP=13766 with signal 10
DEB=13765 looks ok
PID=13765: DEB OK

APP=13766 sleeping for a second
ripley:tjf 265>> APP=13766 looks ok
=== TEST PASSED!


Additional info:
See also https://bugzilla.redhat.com/show_bug.cgi?id=451849
Comment 1 petrosyan 2008-06-17 17:38:23 EDT
Fedora Core 6 and Fedora 7 are no longer maintained.
Can you reproduce this bug in Fedora 8 or Fedora 9?
Comment 2 Jakub Jelinek 2008-06-17 22:18:09 EDT
This has nothing to do with glibc.  ptrace is a syscall.
Comment 3 petrosyan 2008-06-27 13:10:21 EDT
Tom, can you reproduce this bug in Fedora 8 or Fedora 9?
Comment 4 Tom Fleck 2008-06-27 13:14:05 EDT
Sorry, I don't have those available yet.  I've got a vmware machine with FC9 on
it now but no gcc yet.  I'll comment when I've done that.  
Comment 5 Tom Fleck 2008-06-27 13:50:11 EDT
The bug reproduces on FC9 using test-case binary built on rhel4 with gcc 3.4.6,
and a binary built on rhel5 with gcc 4.1.2.  Is that good enough? 
...Tom
Comment 6 petrosyan 2008-06-27 14:57:56 EDT
I could reproduce your bug by compiling and running your test-binaries on Fedora
9 using gcc-4.3.0 on a x86_64 architecture.
Comment 7 Bug Zapper 2009-06-09 21:40:26 EDT
This message is a reminder that Fedora 9 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 9.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '9'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 9's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 9 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 8 Bug Zapper 2009-07-14 14:05:57 EDT
Fedora 9 changed to end-of-life (EOL) status on 2009-07-10. Fedora 9 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.